package SM.diglib;

import java.applet.*;
import java.io.*;
import java.util.*;
import java.net.*;

import org.ginf.*;
import org.ginf.helpers.*;
import org.ginf.delivery.*;
import org.ginf.delivery.HTTP.*;
import org.ginf.schemas.*;

import org.w3c.rdf.*;

//import netscape.security.*;
import netscape.javascript.*;


public class ClientApp extends Applet implements Layer, Comparer {

  //  static Hashtable anchors = new Hashtable(100);
  JSObject win;
  
  RDFFactory factory;
  Layer outside;

  Model storedModel;
  int limit; // to receive

  public void init() {
    super.init();

    try {
      netscape.security.PrivilegeManager.enablePrivilege("Netcaster");
      //    netscape.security.PrivilegeManager.enablePrivilege("UniversalConnect");
      
      factory = new RDFFactoryImpl();
      SchemaRegistryImpl reg = (SchemaRegistryImpl)factory.registry();
      
      reg.addLoader( new DublinCore() ); // do not attempt to download DublinCore schema
      reg.addLoader( new Coll() );
      reg.addLoader( new SDLIP() );
      
      HTTPLayer h = new HTTPLayer(factory);
      //      ConnectionlessTransport t = new ConnectionlessTransport(factory, true);
      connect( "transport", h );
      //      t.connect( "service", this );
      //      t.connect( "http", h);
      
      System.out.println("[ClientApp] started");
      showStatus("GUI Library Client ready!");

    } catch (Exception any) {
      System.err.println("[ClientApp] could not start: " + any);
    }
  }

  Resource comp_by = SDLIP.rank;

  public int compare(Object handle, Object o1, Object o2) {

    Model model = (Model)handle;

    Triple d1 = (Triple)o1;
    Triple d2 = (Triple)o2;

    if(comp_by == null) {
      return d1.object().toString().compareTo(d2.object().toString());
    }

    String r1 = null;
    String r2 = null;
    
    try {
      r1 = model.find1( (Resource)d1.object(), comp_by, null ).object().toString();
    } catch (Exception any) {}
    try {
      r2 = model.find1( (Resource)d2.object(), comp_by, null ).object().toString();
    } catch (Exception any) {}

    if(r1 == null)
      return 1;
    if(r2 == null)
      return -1;

    if (SDLIP.rank.equals(comp_by)) {
      float i1 = -1;
      float i2 = -1;
      try {
	i1 = Float.valueOf( r1 ).floatValue();
      } catch (Exception nfe) {}
      try {
	i2 = Float.valueOf( r2 ).floatValue();
      } catch (Exception nfe) {}

      // higher rank is better!
      if(i1 < i2)
	return 1;
      else if(i2 < i1)
	return -1;
      else if(i1 != -1)
	return 0;
      else
	return System.identityHashCode(r1) - System.identityHashCode(r2);
    }
    
    return r1.compareTo(r2);
    
      //    } catch (Exception any) {

      //      return d1.toString().compareTo(d2.toString());
      //    }
  }

  //  public initApp(JSObject win) {
  //    this.win = win;
  //    display("Ready!");
  //  }

  /**
   * Layer implementation
   */
  public void connect(String what, Layer layer) {
    if("transport".equals(what))
      this.outside = layer;
    else
      throw new IllegalArgumentException("[Client] cannot connect \"" + what + "\"");
  }

  public Model dispatch(Model model, Layer from) throws Exception {

    SchemaModel m = factory.createSchemaModel( model ); // we want to use schema info
    // Validate schema conformance
    //    System.err.println("GOT MODEL");
    //    DefaultModel.printTriples( m, System.err );
    m.validate();
    // check whether is Result

    Resource res = null;

    try {
      res = m.find1( null, RDF.type, SDLIP.Result ).subject();
    } catch (Exception any) {}
      // print some statistics
    try {
      //      Resource request = (Resource)m.find1( res, CoreComm.from, null ).object();
      System.err.println("GOT RESULT FOR: " + m.find1( res, CoreComm.from, null ).object());
    } catch (Exception any) {}


    // process result
    receiveReply( m );

    // wake up
    //    synchronized(this) { notify(); }
    return null;
  }

  //  Thread thread;

  void receiveReply(Model m) throws Exception {

    boolean finished = m != null && m.find( null, RDF.type, CoreState.DiscardState ).size() > 0;
    if(finished)
      m = null; // no useful info in m

    boolean original = (m != null);

    if(m != null) {
      //      limit -= m.find( null, Coll.item, null).size();
      //System.err.println("NEW LIMIT: " + limit);
      if(storedModel == null)
	storedModel = m;
      else
	storedModel.union(m);
      System.err.println("NEW STORED: " + storedModel.size());
    }
    m = storedModel;

    Model items = m.find( null, Coll.item, null );
    System.err.println("ITEMS FOUND: " + items.size());

    if(finished || !original || items.size() % 3 == 0 || items.size() >= limit) {

      StringBuffer b = new StringBuffer();

      // print result size
      //    System.out.println("Result size is: " + m.find1( res, SDLIP.resultSize, null ).object());
      
      //    try {
      b.append("# of result items delivered: " + items.size() + " of " + limit + " requested."); // m.find1( res, SDLIP.resultSize, null ).object());
      //    } catch (Exception any) {}
      
      // print out results
      b.append("<p><ol>");
      
      Vector tv = RDFUtil.getTripleVector(items);
      System.err.println("ITEMS# " + tv.size());
      // sort order: GROUP BY resource, abbreviatable
      QuickSort.sort(tv, this, m);
      
      int count = 0;
      for(Enumeration en_i = tv.elements(); en_i.hasMoreElements(); ) {
	
	Resource item = (Resource)((Triple)en_i.nextElement()).object();
	b.append("<li><b>");
	if(item.toString().startsWith("http:/"))
	  b.append("<a href='" + item + "'><font color='black'>" + item + "</font></a>");
	else
	  b.append(item);
	b.append("</b><br>");
	// print title and author
	//      System.out.println("Title is: " + m.find1( item, DublinCore.Title, null ).object());
	//      System.out.println("Author is: " + m.find1( item, DublinCore.Creator, null ).object());
	
	try {
	  b.append("<font color='darkblue'><b>" + m.find1( item, DublinCore.Title, null ).object() + "</b></font><br>");
	} catch (Exception any) {}
	
	try {
	  b.append("Author(s): " + m.find1( item, DublinCore.Creator, null ).object() + "<br>");
	} catch (Exception any) {}
	
	try {
	  b.append("Rank: <font color='darkred'>" + m.find1( item, SDLIP.rank, null ).object() + "</font>");
	} catch (Exception any) {}
	b.append("<p>");
	
      }
      b.append("</ol>");

      try {
	display("results", b.toString());
      } catch(Exception any) {
	System.err.println(toString() + " could not display: " + any);
      }
    }
    
    if(original && items.size() >= limit)
      hangup(m);
  }


  Resource getStateInfoClass() {
    return HTTP.Connection;
  }

  void hangup(Model m) {
    // hang up
    try {
      Resource state = m.find1( null, RDF.type, getStateInfoClass()).subject();
      System.err.println("STATE: " + state);
      Model hangup = factory.createModel();
      Resource msg = RDFUtil.noname();
      hangup.add( msg, RDF.type, CoreState.DiscardState );
      hangup.add( msg, CoreState.state, state );
      hangup.add( state, RDF.type, CoreState.StateInfo );
      outside.dispatch( hangup, this );
    } catch (Exception any) {
      System.err.println("Could not hang up: " + any);
    }
  }


  void sendRequest(String url, String query, String limit) throws Exception {

    // we construct the model using the API, so fetch the schema manually
    factory.registry().fetch(SDLIP.NS);

    Model m = factory.createModel();
    
    // create new unique unnamed resource
    Resource s = RDFUtil.noname();
    m.add( s, RDF.type, SDLIP.Search ); // this is a Search request
    m.add( s, SDLIP.queryString, query ); // the query
    m.add( s, SDLIP.limit, limit ); // max 10 results
    //    m.add( s, SDLIP.scope, myColl );

    Resource attrs = RDFUtil.noname();
    m.add( s, SDLIP.attributes, attrs); // attributes
    m.add( attrs, RDF.type, RDF.Bag ); // this is a Bag of attribute names
    m.add( attrs, RDFUtil.ord(1), DublinCore.Title ); // 1=Title
    m.add( attrs, RDFUtil.ord(2), DublinCore.Creator ); // 2=Creator

    Resource dest = new Resource( url );
    m.add( s, CoreComm.to, dest );
    m.add( dest, RDF.type, CoreComm.ProcessingEntity);

    Resource con = RDFUtil.noname(); // create new connection
    System.err.println("SENDING REQUEST: " + s);

    //    System.err.println("SENDING MODEL");
    //    factory.createRDFMS().serialize( m, new OutputStreamWriter(System.err) );

    storedModel = null; // factory.createSchemaModel( factory.createModel() );
    this.limit = Integer.parseInt(limit);
    //    if(this.limit <= 0)
    //      this.limit = 10;

    outside.dispatch(m, this);
  }

  void display(String mode, String text) {
    Object[] buffer = new Object[2];
    buffer[0] = mode;
    buffer[1] = text;
    //    System.err.println("Writing to " + win);
    win.call("display", buffer);
  }

//    return doc = (JSObject)win.eval("document");

  public void redraw(String method) {

    if(storedModel == null) {
      System.err.println("No stored model");
      return;
    }
    if("rank".equals(method))
      comp_by = SDLIP.rank;
    else if("title".equals(method))
      comp_by = DublinCore.Title;
    else if("creator".equals(method))
      comp_by = DublinCore.Creator;
    else if("id".equals(method))
      comp_by = null;
    else {
      System.err.println("Unknown redraw type: " + method);
      return;
    }
    try {
      receiveReply( null );
    } catch (Exception any) {
      System.err.println("Could not redraw: " + any);
    }
  }

  public String search(JSObject win, String url, String query, String limit) {

    this.win = win;

    try {
      netscape.security.PrivilegeManager.enablePrivilege("Netcaster");

      //      System.err.println("SEARCH: REQ " + System.currentTimeMillis());

      sendRequest(url, query, limit);
    } catch (Exception any) {
      //      any.printStackTrace( System.err );
      return "Could not make the search: " + any.getMessage();
    }
    return null;
  }
}

