/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */

package org.ginf.helpers;

/**
 * A <em>comparer</em> performs a comparison of
 * two objects.
 *
 * @author Sergey Melnik <melnik@db.stanford.edu>
 */

public interface Comparer {

  /**
   * Handle is used e.g. to distinguish different types of sorting
   * or just passed as an additional parameter.
   *
   * <0: o1 < o2
   *  0: o1 = o2
   * >0: o1 > o2
   */
  public int compare(Object handle, Object o1, Object o2);
}
