package org.ginf.schemas;

import org.ginf.*;
import org.ginf.helpers.*;
import org.w3c.rdf.*;
import org.xml.sax.*;
import java.io.*;

/**
 * This class provides handy access to schema information.
 * THIS FILE HAS BEEN GENERATED AUTOMATICALLY.
 */

public class CoreState implements SchemaLoader {

  /** Namespace URI of this schema */
  public static final String NS = "http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-state";

  /** A reply stating that the state information passed
		it invalid, outdated etc. */
  public static final Resource InvalidState = new Resource(NS + "#InvalidState");

  /** Asks the server to discard session information and to free
		the resources */
  public static final Resource DiscardState = new Resource(NS + "#DiscardState");

  /** A resource representing state information. May have additional
		properties attached to it. To support stateful interface, the client
		must attach StateInfo to every message it sends.
		Otherwise a new session will be initiated. */
  public static final Resource StateInfo = new Resource(NS + "#StateInfo");

  /** A reply stating that the state information was not passed,
		but is required. */
  public static final Resource NoState = new Resource(NS + "#NoState");

  /** Identifies state/session context. Range be a resource. */
  public static final Resource state = new Resource(NS + "#state");


  static final String _schemaData = "<?xml version='1.0' encoding='ISO-8859-1'?>"+
	"<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\""+
	"	 xmlns:s=\"http://www.w3.org/TR/WD-rdf-schema#\">"+
	"<s:Class rdf:ID=\"DiscardState\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Request\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"InvalidState\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Error\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"NoState\">"+
	"	<s:subClassOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Error\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"StateInfo\"/>"+
	"<rdf:Property rdf:ID=\"state\">"+
	"	<s:domain rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#Message\"/>"+
	"	<s:subPropertyOf rdf:resource=\"http://www-diglib.stanford.edu/diglib/ginf/1999/05/26-core-comm#deliveryInfo\"/>"+
	"	<s:range rdf:resource=\"http://www.w3.org/TR/WD-rdf-schema#Resource\"/>"+
	"</rdf:Property>"+
	"</rdf:RDF>"+
	"";

  public boolean loadSchema(String uri, RDFFactory factory) {
    if(NS.equals(uri)) {
      InputSource source = new InputSource( new StringReader( _schemaData ) );
      source.setSystemId(NS);
      factory.registry().fetch(source);
      return true;
    } else
      return false;
  }

}
