package org.ginf.schemas;

import org.ginf.*;
import org.ginf.helpers.*;
import org.w3c.rdf.*;
import org.xml.sax.*;
import java.io.*;

/**
 * This class provides handy access to schema information.
 * THIS FILE HAS BEEN GENERATED AUTOMATICALLY.
 */

public class RDFS implements SchemaLoader {

  /** Namespace URI of this schema */
  public static final String NS = "http://www.w3.org/TR/WD-rdf-schema";

  /** Indicates a resource that provides information about the subject resource */
  public static final Resource seeAlso = new Resource(NS + "#seeAlso");

  /** Use this for descriptions */
  public static final Resource comment = new Resource(NS + "#comment");

  /** Indicates a resource containing and defining the subject resource. */
  public static final Resource isDefinedBy = new Resource(NS + "#isDefinedBy");

  /** Indicates membership of a class */
  public static final Resource subClassOf = new Resource(NS + "#subClassOf");

  /** This is how we associate a class with  properties that its instances can have */
  public static final Resource domain = new Resource(NS + "#domain");

  /** The concept of Class */
  public static final Resource Class = new Resource(NS + "#Class");

  /** Indicates specialization of properties */
  public static final Resource subPropertyOf = new Resource(NS + "#subPropertyOf");

  /** Resources used to express RDF Schema constraints. */
  public static final Resource ConstraintResource = new Resource(NS + "#ConstraintResource");

  /** Properties used to express RDF Schema constraints. */
  public static final Resource ConstraintProperty = new Resource(NS + "#ConstraintProperty");

  /** This is the class that the properties _1,_2, ... that are used to represent lists and are an instance of */
  public static final Resource ContainerMembershipProperty = new Resource(NS + "#ContainerMembershipProperty");

  /** Properties that can be used in a   schema to provide constraints */
  public static final Resource range = new Resource(NS + "#range");

  /** The concept of a property. */
  public static final Resource Property = new Resource(NS + "#Property");

  /** The most general class */
  public static final Resource Resource = new Resource(NS + "#Resource");

  /** This represents the set of atomic values, eg. textual strings. */
  public static final Resource Literal = new Resource(NS + "#Literal");

  /** This represents the set Containers. */
  public static final Resource Container = new Resource(NS + "#Container");

  /** Provides a human-readable version of a resource name */
  public static final Resource label = new Resource(NS + "#label");


  static final String _schemaData = "<?xml version='1.0' encoding='ISO-8859-1'?>"+
	"<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\""+
	"	 xmlns:s=\"http://www.w3.org/TR/WD-rdf-schema#\">"+
	"<s:Class rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Alt\">"+
	"	<s:subClassOf rdf:resource=\"#Container\"/>"+
	"</s:Class>"+
	"<s:Class rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Bag\">"+
	"	<s:subClassOf rdf:resource=\"#Container\"/>"+
	"</s:Class>"+
	"<s:Class rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Seq\">"+
	"	<s:subClassOf rdf:resource=\"#Container\"/>"+
	"</s:Class>"+
	"<s:Class rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<rdf:Property rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#object\">"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#predicate\">"+
	"	<s:range rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#subject\">"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Statement\"/>"+
	"	<s:range rdf:resource=\"#Resource\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#type\">"+
	"	<s:range rdf:resource=\"#Class\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:about=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#value\"/>"+
	"<s:Class rdf:ID=\"Class\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"ConstraintProperty\">"+
	"	<s:subClassOf rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"	<s:subClassOf rdf:resource=\"#ConstraintResource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"ConstraintResource\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"Container\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"ContainerMembershipProperty\">"+
	"	<s:subClassOf rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"Literal\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"Property\">"+
	"	<s:subClassOf rdf:resource=\"#Resource\"/>"+
	"</s:Class>"+
	"<s:Class rdf:ID=\"Resource\"/>"+
	"<rdf:Property rdf:ID=\"comment\">"+
	"	<s:range rdf:resource=\"#Literal\"/>"+
	"	<s:domain rdf:resource=\"#Resource\"/>"+
	"</rdf:Property>"+
	"<s:ConstraintProperty rdf:ID=\"domain\">"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"	<s:range rdf:resource=\"#Class\"/>"+
	"</s:ConstraintProperty>"+
	"<rdf:Property rdf:ID=\"isDefinedBy\">"+
	"	<s:range rdf:resource=\"#Resource\"/>"+
	"	<s:domain rdf:resource=\"#Resource\"/>"+
	"	<s:subPropertyOf rdf:resource=\"#seeAlso\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"label\""+
	"	 s:Label=\"label\">"+
	"	<s:range rdf:resource=\"#Literal\"/>"+
	"	<s:domain rdf:resource=\"#Resource\"/>"+
	"</rdf:Property>"+
	"<s:ConstraintProperty rdf:ID=\"range\">"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"	<s:range rdf:resource=\"#Class\"/>"+
	"</s:ConstraintProperty>"+
	"<rdf:Property rdf:ID=\"seeAlso\">"+
	"	<s:domain rdf:resource=\"#Resource\"/>"+
	"	<s:range rdf:resource=\"#Resource\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"subClassOf\">"+
	"	<s:range rdf:resource=\"#Class\"/>"+
	"	<s:domain rdf:resource=\"#Class\"/>"+
	"</rdf:Property>"+
	"<rdf:Property rdf:ID=\"subPropertyOf\">"+
	"	<s:range rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"	<s:domain rdf:resource=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#Property\"/>"+
	"</rdf:Property>"+
	"</rdf:RDF>"+
	"";

  public boolean loadSchema(String uri, RDFFactory factory) {
    if(NS.equals(uri)) {
      InputSource source = new InputSource( new StringReader( _schemaData ) );
      source.setSystemId(NS);
      factory.registry().fetch(source);
      return true;
    } else
      return false;
  }

}
